/*
Írjatok algoritmust (alprogramot) amely egy természetes számokból álló számsorozatból meghatározza azt a leghosszabb 
tömbszakaszt, amely csak prímszámokat tartalmaz. Bemeneti paraméterek: n – természetes szám (10 ≤ n ≤ 10 000 000) 
a számsorozat hossza, x – természetes számokat tároló tömb. A számok kisebbek, mint 30 000. Kimeneti paraméterek: 
start (a tömbszakasz első elemének indexe) és vége (a tömbszakasz utolsó elemének indexe).
Példa: ha n = 10 és x = (6, 3, 5, 8, 1, 2, 3, 7, 19, 12), akkor start = 6 és vége = 9.
*/

#include <iostream>
#include <fstream>

using namespace std;

int const maxDim = 101;

ifstream fin("pelda.in");

void beOlvas(int & n, int x[]){
// bemeneti adatok beolvasása

	fin >> n; 
	for(int i = 1; i <= n; i++)
		fin >> x[i];	
}

void kiir(int n, int x[]){
// bemeneti adatok kiírása

	cout << "n = " << n << endl;
	for(int i = 1; i <= n; i++)
		cout << x[i] << " ";	
	cout << endl;
}

void kiirTsz(int n, int x[], int start, int vege){
// kimeneti adatok kiírása

	for(int i = start; i <= vege; i++)
		cout << x[i] << " ";	
	cout << endl;
}

bool prim(int n){
// eldönti az n természetes számról, hogy prímszám-e vagy sem

	bool prim;
	
	if(n == 1)
		prim = false;	
	else {
		if(n % 2 == 0)
			prim = (n == 2);					// az egyetlen páros prímszám a 2
		else {									// páratlan számok vizsgálata
			prim = true;
			int oszto = 3;
			while(prim && (oszto * oszto <= n)){// nem számoljuk ki az n szám négyzetgyökét!!!
				if((n % oszto) == 0)
					prim = false;
				else
					oszto += 2; 
			}
		}
	}
	return prim;
}

bool prim_2(int n){
// Egy másik lehetőség: egy kicsit tömörebb, de eltér a strukturált programozás alapszabályaitól

	if(n == 1)
		return false;	
	else {
		if(n % 2 == 0)
			return (n == 2);					// az egyetlen páros prímszám a 2
		else {									// páratlan számok vizsgálata
			for(int oszto = 3; oszto * oszto <= n; oszto += 2)
				if((n % oszto) == 0)
					return false;
			return true;
		}
	}
}

void leghosszabbTombszakasz(int n , int x[], int & start, int & vege){	
// meghatározza azt a tömbszakaszt, amely cak prímszámokat tartalmaz 

	int maxHossz = 0;				// a leghosszabb tömbszakasz hossza
	int kezdet;
	int hossz;						// az aktuális tömbszakasz hossza
	
	int i = 1; 
	while(!prim_2(x[i]) && i <= n)
		i++;						// amikor kilépünk, x[i] prímszám
	
	while(i <= n){
		kezdet = i;					// itt kezdődik az aktuális tömbszakasz
		while(i <= n && prim_2(x[i]))
			i++;					// amikor kilépünk, x[i] NEM prímszám
		hossz = i - kezdet;			// nincs szükség kivonni 1-et, mivel i 1-gyel nagyobb, mint az utolso primszam indexe
		if(hossz > maxHossz){
			maxHossz = hossz;
			start = kezdet;
			vege = i - 1;			// i 1-gyel nagyobb
		}
        i++;
	}
}

int main(){

	int n, start, vege;
	int x[maxDim]; 

	beOlvas(n, x);
	kiir(n, x);
	
	leghosszabbTombszakasz(n, x, start, vege);	
	
	cout << "Leghosszabb tombszakasz, amely csak primszamokat tartalmaz ";
	cout << "a " << start << ". pozicion kezdodik, es a " << vege << ". pozicion er veget: " << endl;
	kiirTsz(n, x, start, vege);
} 
