/*
Nyeregpontok
Adott egy n soros és m oszlopos (0 < n, m ≤ maxDim), egész számokat tároló kétdimenziós a tömb. 
Írjatok algoritmust, amely megszámolja a tömb nyeregpontjait! Egy a[i][j] elemet nyeregpontnak nevezünk, 
ha az a[i][j] elem legnagyobb a j. oszlopban és legkisebb az i. sorban, és fordítva. 
Az algoritmus bemeneti paraméterei n és a, kimeneti paraméterek a nyeregpontok darabszáma (k) és az indexeik.
*/

#include <iostream>
#include <fstream>
using namespace std;

ifstream f("nyereg_5.in");

int const maxDim = 101;

void beolvas(int & n, int &m, int a[][maxDim]){
// a bemeneti adatok beolvasása

    f >> n >> m;
    for(int i = 1; i <= n; i++)
        for(int j = 1; j <= m; j++)
            f >> a[i][j];
}

void kiir(int  n, int m, int a[][maxDim]){
// a bemeneti adatok kiírása

    cout << "n = " << n << " m = " << m << endl;
    cout << "A matrix:" << endl;
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= m; j++)
            cout << a[i][j] << " ";
        cout << endl;
    }
}

void minimumSoronkent(int a[][maxDim], int n, int m, int i, int sorokMinimumai[], int & minSorHossza){
// meghatározzuk azokat az oszlopindexeket az i. sorban, ahol a sor minimumával egyenlõ érték található
// a sorokMinimumai sorozat hossza: minSorHossza

	minSorHossza = 1;					// most foglalkozunk az első lehetséges minimummal
	int sorMinErtek = a[i][1];				// a sorban található legkisebb érték
	sorokMinimumai[1] = 1;				// a sorozat, ahol a minimumértékek oszlopindexeit tároljuk
	for(int k = 2; k <= m; k++){
		if(sorMinErtek > a[i][k]){
			minSorHossza = 1;
			sorMinErtek = a[i][k];
			sorokMinimumai[minSorHossza] = k;	// mentjük az indexet
		}
		else
			if(sorMinErtek == a[i][k]){			// a minimum többször is elõfordul az i. sorban 
				minSorHossza++;
				sorokMinimumai[minSorHossza] = k;// mentjük az indexet
			}
	}
}

void maximumOszloponkent(int a[][maxDim], int n, int m, int i, int sorokMinimumai[], int minSorHossza, int & db, int sorIndex[], int oszlopIndex[], bool voltMar[][maxDim]){
// bejárjuk azokat az oszlopokat, ahol az i. sor egy-egy "minimumértéke" található, és meghatározzuk az oszlop maximumát
// ha az oszlop maximuma az i. sorban található, akkor ez nyeregpont
	
	for(int q = 1; q <= minSorHossza; q++){		// bejárjuk az i. sor minimumértékeinek megfelelõ indexek sorozatát 
		int maxi = a[1][sorokMinimumai[q]];		// a maximumérték inicializálása
		for(int p = 2; p <= n; p++)				// bejárjuk rendre azokat az oszlopokat, ahol egy-egy sor-minimum található
			if(maxi < a[p][sorokMinimumai[q]]){
				maxi = a[p][sorokMinimumai[q]];
			}
		
		if(maxi == a[i][sorokMinimumai[q]]){	// a sorokMinimumai[q] oszlop maximuma egyenlõ az i. sor minimumával
			if(!(voltMar[i][sorokMinimumai[q]])){
				db++;								// nő a nyeregpontok száma
				sorIndex[db] = i;
				oszlopIndex[db] = sorokMinimumai[q];
				voltMar[i][sorokMinimumai[q]] = true;
			}
		}	
	}
}

void maximumSoronkent(int a[][maxDim], int n, int m, int i, int sorokMaximumai[], int & maxSorHossza){
// meghatározzuk azokat az oszlopindexeket az i. sorban, ahol a sor maximumával egyenlõ érték található
// a sorokMaximumai sorozat hossza: maxSorHossza

	maxSorHossza = 1;
	int maxi = a[i][1];
	sorokMaximumai[1] = 1;
	for(int k = 2; k <= m; k++){
		if(maxi < a[i][k]){
			maxSorHossza = 1;
			maxi = a[i][k];
			sorokMaximumai[maxSorHossza] = k;	// mentjük az indexet
		}
		else
			if(maxi == a[i][k]){				// a maximum többször is elõfordul az i. sorban
				maxSorHossza++;
				sorokMaximumai[maxSorHossza] = k;// mentjük az indexet
			}
	}
}

void minimumOszloponkent(int a[][maxDim], int n, int m, int i, int sorokMaximumai[], int maxSorHossza, int & db, int sorIndex[], int oszlopIndex[], bool voltMar[][maxDim]){
// bejárjuk azokat az oszlopokat, ahol az i. sor egy-egy "maximumértéke" található, és meghatározzuk az oszlop minimumát
// ha az oszlop minimuma az i. sorban található, akkor ez nyeregpont
	
	for(int q = 1; q <= maxSorHossza; q++){	// bejárjuk az i. sor maximumértékeinek megfelelõ indexek sorozatát
		int mini = a[1][sorokMaximumai[q]];	// a minimérték inicializálása 
		for(int p = 2; p <= n; p++)			// bejárjuk rendre azokat az oszlopokat, ahol egy-egy sor-maximum található
			if(mini > a[p][sorokMaximumai[q]]){
				mini = a[p][sorokMaximumai[q]];
			}
		if(mini == a[i][sorokMaximumai[q]]){	// a sorokMaximumai[q] oszlop minimuma egyenlõ az i. sor minimumával
			if(!(voltMar[i][sorokMaximumai[q]])){
				db++;								// nő a nyeregpontok száma
				sorIndex[db] = i;
				oszlopIndex[db] = sorokMaximumai[q];
				voltMar[i][sorokMaximumai[q]] = true;
			}
		}
	}
}

void nyeregpontok(int a[][maxDim], int n, int m, int & db, int sorIndex[], int oszlopIndex[], bool voltMar[][maxDim]){
    
    int sorokMinimumai[maxDim];
    int sorokMaximumai[maxDim];
    int minSorHossza;
    int maxSorHossza;
    db = 0;
        
    for(int i = 1; i <= n; i++){			// bejárjuk a tömb sorait
		minimumSoronkent(a, n, m, i, sorokMinimumai, minSorHossza);	
		// sorokMinimumai azon oszlopindexeket tároló sorozat, ahol az i. sor azonos minimumértékei találhatók 
		
		maximumOszloponkent(a, n, m, i, sorokMinimumai, minSorHossza, db, sorIndex, oszlopIndex, voltMar);
		// db = azon elemek darabszáma, amelyek minimumok a sorukban és maximumok az oszlopukban: nyeregpontok
		
		maximumSoronkent(a, n, m, i, sorokMaximumai, maxSorHossza);	
		// sorokMaximumai azon oszlopindexeket tároló sorozat, ahol az i. sor azonos maximumértékei találhatók 
		
		minimumOszloponkent(a, n, m, i, sorokMaximumai, maxSorHossza, db, sorIndex, oszlopIndex, voltMar);
		// db = azon elemek darabszáma, amelyek maximumok a sorukban és minimumok az oszlopukban: nyeregpontok
	}
}

void kiIrEredmeny(int db, int sorIndex[], int oszlopIndex[]){
// eredmények kiírása

	if(db){
		cout << "Osszesen " << db << " nyeregpont talalhato a matrixban." << endl;
		cout << "Poziciok:" << endl;
		for(int i = 1; i <= db; i++)
			cout << "[" << sorIndex[i] << ", "<< oszlopIndex[i] << "]" << endl;
	}
	else
		cout << "Nincs nyeregpont!" << endl;
}

void init(int n, bool voltMar[][maxDim]){

	for(int i = 1; i <= n ; i++)
		for(int j = 1; j <= n; j++)
			voltMar[i][j] = false;
}

int main(){
    int n, m;						// a mátrix dimenziói
    int db;							// nyeregpontok száma
    int a[maxDim][maxDim];			// az adott mátrix
    int sorIndex[maxDim], oszlopIndex[maxDim];// a nyeregpontok pozicioi
    bool voltMar[maxDim][maxDim];

    beolvas(n, m, a);
    kiir(n, m, a);

    init(n, voltMar);

    nyeregpontok(a, n, m, db, sorIndex, oszlopIndex, voltMar);
    kiIrEredmeny(db, sorIndex, oszlopIndex);
    return 0;
}


